/*******************
 *
 * Copyright 1999-2002 IAR Systems. All rights reserved.
 *
 * $Revision: 1.2.1.2 $
 *
 * This code does two things to support debugging in an angel environment
 *  - Output to stdout and stderr to the angel swi handler
 *  - When __exit is reached the proper angel swi call is made
 *
 * The following linker settings works with armsd
 *   xlink -Felf -yas -f <lnkcfg> angel.r79 <library> .....
 *
 ********************/


#include <stdio.h>
#include <string.h>
#include <yfuns.h>               

#ifdef __cplusplus
extern "C" {
#endif

#pragma language = extended

#if __CPU_MODE__ == 1
#define ANGEL_VECTOR=0xAB
#elif __CPU_MODE__ == 2
#define ANGEL_VECTOR=0x123456
#endif

#pragma swi_number=ANGEL_VECTOR
__swi __arm void angel_SysCall( int callId, int param );



size_t __write(int Handle, const unsigned char *Buf, size_t BufSize)
{               
  if (Handle == 1 || Handle == 2)
  {           
    unsigned char lbuf[128];
    int index = 0;
    
    while( index < BufSize )
    {
      int lbs = BufSize - index;
      if( lbs > 127 )
        lbs = 127;

      memcpy( lbuf, &Buf[index], lbs );
      lbuf[ lbs ] = '\0'; 
             
      angel_SysCall( 4, ( int )lbuf );  
      
      index += lbs;    
    }                   
    return index;
  }
  else      
  {
    return -1;
  }
}                   

void __exit( int i )
{
  angel_SysCall( 0x18, 0x20026 );
}

#ifdef __cplusplus
};
#endif


