
/*
 * $Revision: 1.2 $
 */

#include <stdio.h>
#include <string.h>
#include "config.h"
#include "timer.h"

int led_slow_speed = 0; // LED moving pattern speed flag.

// LED moving pattern codes.
static int led_table[] = {
  0x18, 0x3c, 0x7e, 0xff, 0xe7, 0xc3, 0x81, 0x42, 0x24, -1
};

void main(void)
{
  // Set up peripheral registers.
  JOBInitPIO(&led_slow_speed);
  // First disable interrupts.
  __disable_interrupt();
  // Setup interrupt controller.
  JOBInitInterrupt(TimerBeat);
  // Periodic timer initialization.
  JOBInitTimer();
  // Enable interrupts.
  __enable_interrupt();

  // Start periodic timer.
  JOBStartTimer();

  // Initial LED pattern.
  JOBLedSet(0x18);
  // Display pattern for 1 second.
  Sleep(1000);
  // Next LED pattern.
  JOBLedSet(0xc3);
  // Display pattern for 1 second.
  Sleep(1000);

  // Loop forever.
  for (;;)
  {
    int *ip;

    // Loop over all LED patterns in table.
    for (ip = led_table; *ip != -1; ip++)
    {
      // Update LED's.
      JOBLedSet(*ip);
      Sleep(led_slow_speed ? 200 : 75);
    }
  }
}
