
/*
 * $Revision: 1.3 $
 */
 
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <yfuns.h>

#include "FileIO.h"

static unsigned char buf[CHUNK];
static unsigned char* bufp;
static int log_fd = -1;
static char logname[128];
static int logname_valid = 0;

int FileReadByte(int fd)
{                        
  int c;
  static int remaining = 0;

  if (remaining == 0)
  {
    remaining = __read(fd, buf, CHUNK);
    if (remaining == 0)
    {
      FileLogMessage("Found unexpected EOF in file.\n");
      FileExit();
    }
    bufp = buf;
  }
  c = *bufp++;
  --remaining;

  return c;
}

int FileOpen(char* name)
{
  int fd;
  
  fd = __open(name, _LLIO_RDONLY | _LLIO_BINARY);

  return fd;
}


void FileClose(int fd)
{
  __close(fd);
}


void FileLogMessage(char* msg)
{
  if (logname_valid)
    return;
    
  if (log_fd == -1)
  {
    log_fd = __open(logname, _LLIO_CREAT | _LLIO_TRUNC | _LLIO_WRONLY);

    if (log_fd == -1)
    {
      FileExit();
    }
  }
  __write(log_fd, (unsigned char *)msg, strlen(msg));
}

void FileLogName(char* name)
{
  strcpy(logname, name);
}

void FileExit()
{
  if (log_fd != -1)
  {
    __close(log_fd);
    log_fd = -1;
  }

  exit(0);
}
