/* Low-level debugger interface to the "__dwrite" function. */
/* Copyright (C) 2003 IAR Systems.  All rights reserved. */

/* This function makes it possible for users to override the __write
 * function and still be able to output information in the Terminal
 * I/O window. */

#include "__dbg_.h"
#include <stdio.h>
#include <yfuns.h>

#pragma cspy_support = io
#pragma module_name = "?__dwrite"

typedef struct __Debug__writeParams
{
  int mHandle;
  unsigned char const *mBuffer;
  size_t mSize;
  size_t mReturnStatus;
} __Debug__writeParams;

size_t __dwrite(int handle, const unsigned char *buf, size_t size)
{
  /* Write some bytes. */
  __Debug__writeParams p;
  p.mHandle = handle;
  p.mBuffer = buf;
  p.mSize = size;
  __DebugBreak(__DebugWrite, &p);

  return p.mReturnStatus;
}
