/* fgetwc function */
#include <string.h>
#include "xwstdio.h"

#if _DLIB_FILE_DESCRIPTOR

_STD_BEGIN

wint_t (fgetwc)(FILE *str)
	{	/* get a wchar_t from wide stream */
	_Lockfileatomic(str);
	if (str->_WRback < str->_WBack
		 + sizeof (str->_WBack) / sizeof (wchar_t))
		{	/* deliver putback character */
		wint_t ch = *str->_WRback++;

		_Unlockfileatomic(str);
		return (ch);
		}

	for (; ; )
		{	/* loop until wide char built */
		int nc;
		wchar_t wc;

		if (str->_Next < str->_WRend)
			;
		else if (_WFrprep(str) <= 0)
			{	/* nothing to read */
			_Unlockfileatomic(str);
			return (WEOF);
			}

		switch (nc = _Mbtowc(&wc, (const char *)str->_Next,
			str->_WRend - str->_Next, &str->_Wstate))
			{	/* check completion code */
		case -2:	/* not done yet */
                        str->_Next = str->_WRend;
			break;

		case -1:	/* bad multibyte character */
			str->_Mode |= _MERR;
			_Unlockfileatomic(str);
			return (WEOF);

		case 0:	/* may be null character */
			if (wc == L'\0')
				nc = strlen((const char *)str->_Next) + 1;
			/* fall through */

		default:	/* got a character */
			str->_Next +=  nc;
			_Unlockfileatomic(str);
			return (wc);
			}
		}
	}
_STD_END

#endif /* _DLIB_FILE_DESCRIPTOR */

/*
 * Copyright (c) 1992-2001 by P.J. Plauger.  ALL RIGHTS RESERVED.
 * Consult your license regarding permissions and restrictions.
V3.10:0576 */
