/* freopen function */
#include <stdlib.h>
#include "xstdio.h"

#if _DLIB_FILE_DESCRIPTOR

_STD_BEGIN

FILE *(freopen)(const char *name, const char *mods,
	FILE *str)
	{	/* reopen a file */
	unsigned short mode;

	_Locksyslock(_LOCK_STREAM);
	mode = str->_Mode & _MALFIL;
	str->_Mode &= ~_MALFIL;
	fclose(str);
	str->_Mode = mode;

	_Lockfileatomic(str);
	str = _Foprep(name, mods, str, _FD_INVALID);
	_Unlockfileatomic(str);

	_Unlocksyslock(_LOCK_STREAM);
	return (str);
	}
_STD_END

#endif /* _DLIB_FILE_DESCRIPTOR */

/*
 * Copyright (c) 1992-2002 by P.J. Plauger.  ALL RIGHTS RESERVED.
 * Consult your license regarding permissions and restrictions.
V3.12:0576 */
