/* puts function */
/* Copyright (C) 2003 IAR Systems.  All rights reserved. */

#include "xstdio.h"

_STD_BEGIN

#if _DLIB_FILE_DESCRIPTOR

int (puts)(const char *s)
	{	/*	put string + newline to stdout */
	int ans;

	_Lockfileatomic(stdout);
	ans = fputs(s, stdout) < 0 || fputc('\n', stdout) < 0 ? EOF : 0;
	_Unlockfileatomic(stdout);
	return (ans);
	}

#else

#include <yfuns.h>
#include <string.h>

int (puts)(const char *s)
	{	/*	put string + newline to stdout */
	int ans;
        static const unsigned char newline = '\n';

	ans = (   __write(_LLIO_STDOUT, (unsigned char const *)s,
                          strlen(s)) == _LLIO_ERROR
               || __write(_LLIO_STDOUT, &newline, 1) == _LLIO_ERROR ? EOF : 0);

	return (ans);
	}

#endif /* _DLIB_FILE_DESCRIPTOR */

_STD_END

/*
 * Copyright (c) 1992-2002 by P.J. Plauger.  ALL RIGHTS RESERVED.
 * Consult your license regarding permissions and restrictions.
V3.12:0576 */
