/******************************************************************************
*                                                             \  ___  /       *
*                                                               /   \         *
* Edison Design Group C++  Runtime                           - | \^/ | -      *
*                                                               \   /         *
* Proprietary information of Edison Design Group Inc.         /  | |  \       *
* Copyright 1992 Edison Design Group Inc.                        [_]          *
*                                                                             *
******************************************************************************/
/*

Declarations for runtime routines for vector new() and delete() functionality.

*/

#ifndef VEC_NEWDEL_H
#define VEC_NEWDEL_H

#include "runtime.h"

#if EXCEPTION_HANDLING
EXTERN_C void *__vec_new_eh(void                         *array_ptr,
                            __vec_element_count_t        number_of_elements,
                            size_t                       element_size,
                            a_constructor_ptr	 	 ctor,
                            a_destructor_ptr	         dtor);
#endif /* EXCEPTION_HANDLING */

#pragma language = extended

#define __VAR_MEM_HELPER1__(M, I)                                             \
EXTERN_C void M *M##_vec_new(void M              *array_ptr,                  \
                             M##_size_t          number_of_elements,          \
                             M##_size_t          element_size,                \
                             M##_constructor_ptr ctor);                       \
                                                                              \
EXTERN_C void M *M##_vec_construct(void M            *array_ptr,              \
                                   M##_size_t          number_of_elements,    \
                                   M##_size_t          element_size,          \
                                   M##_constructor_ptr ctor);                 \
                                                                              \
EXTERN_C void M##_vec_delete(void M                *array_ptr,                \
                             M##_size_t            number_of_elements,        \
                             M##_size_t            element_size,              \
                             M##_destructor_ptr    dtor,                      \
                             int                   delete_flag,               \
                             int                   /*unused_arg*/);           \
                                                                              \
EXTERN_C void M##_vec_destroy(void M                *array_ptr,               \
                              M##_size_t            number_of_elements,       \
                              M##_size_t            element_size,             \
                              M##_destructor_ptr    dtor);
__VAR_MEMORY_LIST1__()
#undef __VAR_MEM_HELPER1__

#pragma language = default

#pragma object_attribute = __noreturn
EXTERN_C void _array_pointer_not_from_vec_new();

/*
Type name used by the exception handling mechanism to point to the
structure used to maintain information about array new and delete
operations that are in process.
*/
typedef struct an_array_alloc_eh_info *an_array_alloc_eh_info_ptr;

#endif /* ifndef VEC_NEWDEL_H */

/******************************************************************************
*                                                             \  ___  /       *
*                                                               /   \         *
* Edison Design Group C++  Runtime                           - | \^/ | -      *
*                                                               \   /         *
* Proprietary information of Edison Design Group Inc.         /  | |  \       *
* Copyright 1992 Edison Design Group Inc.                        [_]          *
*                                                                             *
******************************************************************************/
