/* _Getstr function */
#include <ctype.h>
#include <string.h>
#include "xwchar.h"
#include "xstdio.h"
_STD_BEGIN

#if _DLIB_SCANF_SPECIFIER_SCANSET
static int ranmatch(const char *s, int c, size_t n)
{	/* look for c in [] with ranges */
  const unsigned char uc = c;
  const unsigned char *su = (const unsigned char *)s;

  while (3 <= n)
    if (su[1] == '-')
      if (su[0] <= uc && uc <= su[2])
        return (1);
      else
        su += 3, n -= 3;
    else if (su[0] == uc)
      return (1);
    else
      ++su, --n;
  for (; 0 < n; ++su, --n)
    if (su[0] == uc)
      return (1);
  return (0);
}
#endif /* _DLIB_SCANF_SPECIFIER_SCANSET */

int _Getstr(_Sft *px, int sfl)
{	/* convert %[] (sfl < 0), %c (sfl == 0), else %s */
#if _DLIB_SCANF_SPECIFIER_SCANSET
  char comp;
  char range = 0;
  const char *t;
  int nset;
#endif /* _DLIB_SCANF_SPECIFIER_SCANSET */

  char seen = 0, *s;
  int ch;
#if _DLIB_SCANF_MULTIBYTE
#if _DLIB_SCANF_QUALIFIERS
  int wfl = px->qual == 'l';
#else
  int wfl = 0;
#endif /* _DLIB_SCANF_QUALIFIERS */
  wchar_t *p;
  _Mbstinit(mbst);
#endif /* _DLIB_SCANF_MULTIBYTE */

#if _DLIB_SCANF_SPECIFIER_SCANSET
  if (sfl < 0)
  {	/* parse [] in format */
    comp = *++px->s == '^' ? *px->s++ : '\0';
    t = strchr(*px->s == ']' ? px->s + 1 : px->s, ']');
    if (t == 0)
      return (0);
    nset = t - px->s;
    if (3 <= nset && memchr(px->s + 1, '-', nset - 2))
      range = 1;
  }
#endif /* _DLIB_SCANF_SPECIFIER_SCANSET */
#if _DLIB_SCANF_WIDTH
  px->nget = 0 < px->width ? px->width :
    sfl != 0 ? INT_MAX : 1;
#else
  px->nget = sfl != 0 ? INT_MAX : 1;
#endif
#if _DLIB_SCANF_ASSIGNMENT_SUPPRESSING
  if (px->noconv)
    ;
#else
  if (0) ;
#endif
#if _DLIB_SCANF_MULTIBYTE
  else if (wfl)
    p = va_arg(px->ap, wchar_t *);
#endif
  else
    s = va_arg(px->ap, char *);
  while ((ch = GETN(px)) != EOF)
    if (   0 < sfl && isspace(ch)
#if _DLIB_SCANF_SPECIFIER_SCANSET
        ||    sfl < 0
           && (   !range && (   !comp && !memchr(px->s, ch, nset)
                             || comp && memchr(px->s, ch, nset))
               || range && (   !comp && !ranmatch(px->s, ch, nset)
                            || comp && ranmatch(px->s, ch, nset)))
#endif /* _DLIB_SCANF_SPECIFIER_SCANSET */
        )
      break;
#if !_DLIB_SCANF_MULTIBYTE
    else
#else
    else if (!wfl)
#endif /* _DLIB_SCANF_MULTIBYTE */
    {	/* deliver a single byte */
      seen = 2;
#if _DLIB_SCANF_ASSIGNMENT_SUPPRESSING
      if (!px->noconv)
#endif
        *s++ = ch, px->stored = 1;
    }
#if _DLIB_SCANF_MULTIBYTE
    else
    {	/* build a wchar_t */
      char buf[MB_LEN_MAX];
      int n, nc;
      wchar_t wc;

      buf[0] = ch;
      for (nc = 1; ; )
        switch (n = _Mbtowc(&wc, buf, nc, &mbst))
        {	/* try to build a wchar_t */
        case -2:
          seen |= 1;	/* partial wchar_t */
          if (++nc <= sizeof (buf) && (ch = GETN(px)) != EOF)
            break;	/* try again with more chars */

        case -1:
          for (; 0 < nc; )
          {	/* stop on conversion error */
            int ch = buf[--nc];
            UNGETN(px, ch);
          }
          return (seen ? 0 : EOF);

        case 0:
          if (wc == L'\0')	/* may be null wide char */
            n = strlen(buf) + 1;

        default:	/* fall through */
          for (; n < nc; )	/* got a wchar_t, count and deliver */
          {	/* return unused chars */
            int ch = buf[--nc];
            UNGETN(px, ch);
          }
#if _DLIB_SCANF_ASSIGNMENT_SUPPRESSING
          if (!px->noconv)
#endif
            *p++ = wc, px->stored = 1;
#if _DLIB_SCANF_WIDTH
          --px->width;
#endif
          seen = 2;	/* whole wchar_t */
        }
    }
#endif /* _DLIB_SCANF_MULTIBYTE */
  UNGETN(px, ch);
  if (sfl == 0 || seen != 2)
    return (seen & 1 ? 0 : seen & 2 ? 1 : EOF);
  if (!seen)
    return (ch == EOF ? EOF : 0);
#if _DLIB_SCANF_ASSIGNMENT_SUPPRESSING
  if (px->noconv)
    ;
#else
  if (0) ;
#endif
#if _DLIB_SCANF_MULTIBYTE
  else if (wfl)
    *p = L'\0';
#endif /* _DLIB_SCANF_MULTIBYTE */
  else
    *s = '\0';
#if _DLIB_SCANF_SPECIFIER_SCANSET
  if (sfl < 0)
    px->s = t;
#endif
  return (1);
}
_STD_END

/*
 * Copyright (c) 1992-2002 by P.J. Plauger.  ALL RIGHTS RESERVED.
 * Consult your license regarding permissions and restrictions.
V3.12:0576 */
