/* _LDtest function -- IEEE 754 version */
#define _FLOATING_NO_INLINES
#include "xmath.h"
_STD_BEGIN

#ifndef _LONG_DOUBLE_IS_DOUBLE

 #if __LONG_DOUBLE_SIZE__ == 4

  #ifdef _FLOATING_LESS_INLINES
   #include "xxtl.h"
   #include "xxdtest4.h"
  #endif /* _FLOATING_LESS_INLINES */

 #elif __LONG_DOUBLE_SIZE__ == 8

  #ifdef _FLOATING_LESS_INLINES
   #include "xxtl.h"
   #include "xxdtest8.h"
  #endif /* _FLOATING_LESS_INLINES */

 #else /* ! __DOUBLE_SIZE__ == 4 or 8 */

 #if _DLONG == 0
short _LDtest(long double *px)
  {       /* categorize *px -- 64-bit */
    return (_Dtest((double *)px));
  }

 #elif _DLONG == 1
  short _LDtest(long double *px)
  {       /* categorize *px -- 80-bit */
	unsigned short *ps = (unsigned short *)(char *)px;
    short xchar = ps[_L0] & _LMASK;

    if (xchar == _LMAX)
      return (   (ps[_L1] & 0x7fff) != 0
#if !__NAN_HAS_HIGH_MANTISSA_BIT_SET__
              || ps[_L2] != 0 || ps[_L3] != 0 || ps[_L4] != 0
#endif
               ? _NANCODE : _INFCODE);
    else if (0 < xchar || ps[_L1] != 0
#if __SUBNORMAL_FLOATING_POINTS__
             || ps[_L2] || ps[_L3] || ps[_L4]
#endif
            )
      return (_FINITE);
    else
      return (0);
  }

 #else  /*      1 < _DLONG */
  short _LDtest(long double *px)
  {       /* categorize *px -- 128-bit SPARC */
	unsigned short *ps = (unsigned short *)(char *)px;
    short xchar = ps[_L0] & _LMASK;

    if (xchar == _LMAX)
      return (ps[_L1] != 0
#if !__NAN_HAS_HIGH_MANTISSA_BIT_SET__
              || ps[_L2] != 0 || ps[_L3] != 0
              || ps[_L4] != 0 || ps[_L5] != 0 || ps[_L6] != 0
              || ps[_L7] != 0
#endif
              ? _NANCODE : _INFCODE);
    else if (0 < xchar || ps[_L1]
#if __SUBNORMAL_FLOATING_POINTS__
             || ps[_L2] || ps[_L3]
             || ps[_L4] || ps[_L5] || ps[_L6] || ps[_L7]
#endif
            )
      return (_FINITE);
    else
      return (0);
  }
#endif /* _DLONG == xx */

#endif /* __LONG_DOUBLE_SIZE__ == 4 */
#endif /* _LONG_DOUBLE_IS_DOUBLE */

_STD_END

/*
 * Copyright (c) 1992-2002 by P.J. Plauger.  ALL RIGHTS RESERVED.
 * Consult your license regarding permissions and restrictions.
V3.12:0576 */
