/* The "C" locale. */
/* Copyright (C) 2003 IAR Systems.  All rights reserved. */

#include <locale.h>
#include <ctype.h>
#include <wctype.h>
#include <limits.h>

#include <xtinfo.h>
#include <xinstantiate.h>
#include <xlocale_c.h>

                /* static data */
static const char alt_digits[] = "";
static const char am_pm[] = ":AM:PM";
static const char days[] =
        ":Sun:Sunday:Mon:Monday:Tue:Tuesday:Wed:Wednesday"
        ":Thu:Thursday:Fri:Friday:Sat:Saturday";
static const char era[] = "";
static const char fmts[] =
        "|%a %b %e %T %Y|%m/%d/%y|%H:%M:%S|%I:%M:%S %p";
static const char isdst[] = "";
static const char mons[] =
        ":Jan:January:Feb:February:Mar:March"
        ":Apr:April:May:May:Jun:June"
        ":Jul:July:Aug:August:Sep:September"
        ":Oct:October:Nov:November:Dec:December";
static const char tzone[] = ""; /* adapt by default */

const _Tinfo _LocaleC_Tinfo =
{
  am_pm,
  days,                         /* days, abday, day */
    days, days,
  mons,                         /* months, abmon, mon */
    mons, mons,
  fmts,              /* formats, d_t_fmt, d_fmt, t_fmt, t_fmt_am_pm */
    fmts, fmts, fmts, fmts,
  fmts,                         /* as above, for era */
    fmts, fmts, fmts, fmts,
  era,                          /* era */
  alt_digits,                   /* alt_digits */
  isdst,                        /* isdst */
  tzone                         /* tzone */
};

const char _LocaleC_Name[] = "C";


const struct lconv _LocaleC_lconv =
{
  "", "", "", "", "", "", "",
  CHAR_MAX, CHAR_MAX, CHAR_MAX, CHAR_MAX,
  CHAR_MAX, CHAR_MAX, CHAR_MAX, CHAR_MAX,
  ".",
  "", "", "", "",
  "false",
  "true",
  "",
  ""
};

/* C locale: 1-to-1 inline. */
unsigned short const * const _LocaleC_CollateTable [] = { 0 };
unsigned short const * const _LocaleC_WCollateTable[] = { 0 };


_INSTANTIATE(_LocaleC_islower);
_INSTANTIATE(_LocaleC_isupper);
_INSTANTIATE(_LocaleC_isalpha);
_INSTANTIATE(_LocaleC_iscntrl);
_INSTANTIATE(_LocaleC_ispunct);
_INSTANTIATE(_LocaleC_isspace);
_INSTANTIATE(_LocaleC_tolower);
_INSTANTIATE(_LocaleC_toupper);


/*
 * Define toWxxx functions.
 */

#define DEF_TOWXXX(f)                           \
wint_t _LocaleC_tow##f(wint_t c)                \
{                                               \
  if (c <= 0xFF)                                \
  {                                             \
    return _LocaleC_to##f(c);                   \
  }                                             \
  else                                          \
  {                                             \
    return c;                                   \
  }                                             \
}

DEF_TOWXXX(upper)
DEF_TOWXXX(lower)


/*
 * Define isWxxx functions.
 */

#define DEF_ISWXXX(f)                           \
int _LocaleC_isw##f(wint_t c)                   \
{                                               \
  if (c <= 0xFF)                                \
  {                                             \
    return _LocaleC_is##f(c);                   \
  }                                             \
  else                                          \
  {                                             \
    return 0;                                   \
  }                                             \
}


DEF_ISWXXX(lower)
DEF_ISWXXX(upper)
DEF_ISWXXX(alpha)
DEF_ISWXXX(cntrl)
DEF_ISWXXX(punct)
DEF_ISWXXX(space)


#define DEF_ISWXXX_2(f)                         \
int _LocaleC_isw##f(wint_t c)                   \
{                                               \
  if (c <= 0xFF)                                \
  {                                             \
    return is##f(c);                            \
  }                                             \
  else                                          \
  {                                             \
    return 0;                                   \
  }                                             \
}

DEF_ISWXXX_2(digit)
DEF_ISWXXX_2(xdigit)

/*
 * Copyright (c) 1992-2002 by P.J. Plauger.  ALL RIGHTS RESERVED.
 * Consult your license regarding permissions and restrictions.
V3.12:0576 */
