/* _Putstr function */
#include <yvals.h>
#if _DLIB_PRINTF_MULTIBYTE

#include <string.h>
#include <stdlib.h>
#include "xstdio.h"
#include "xwchar.h"
_STD_BEGIN

#define BUF_SIZE        64

int _Putstr(_Pft *px, const wchar_t *pwc)
{       /* convert wchar_t string to text */
  char ac[BUF_SIZE < MB_LEN_MAX ? MB_LEN_MAX : BUF_SIZE];
  char buf[MB_LEN_MAX], *pac;
#if _DLIB_PRINTF_WIDTH_AND_PRECISION
  int m = px->prec < 0 ? INT_MAX : px->prec;
  size_t acsize = px->width + MB_CUR_MAX;
#else
  int m = INT_MAX;
  size_t acsize = MB_CUR_MAX;
#endif
  int n, stat;
  _Mbstinit(mbst);

#if _DLIB_PRINTF_FLAGS
  if (px->flags & _FMI || acsize <= sizeof (ac))
#else
  if (acsize <= sizeof (ac))
#endif
    pac = ac, acsize = sizeof (ac);
  else if ((pac = (char *)malloc(acsize)) == 0)
    return (EOF);
  for (stat = 0; 0 < m; ++pwc, m -= n)
  {       /* convert a wide character */
    if (   (n = _Wctomb(buf, *pwc, &mbst)) < 0
        || *pwc == 0 && --n < 0)
    {       /* stop on bad conversion */
      stat = EOF;
      break;
    }
    else if (m < n)
      break;  /* precision exhausted */
    if (acsize < px->n0 + n)
    {       /* drain buffer */
#if _DLIB_PRINTF_WIDTH_AND_PRECISION
      px->width = 0;
#endif
      _Puttxt(px, pac);
      px->n0 = 0;
    }
    memcpy(&pac[px->n0], buf, n);
    px->n0 += n;
    if (*pwc == L'\0')
      break;
  }
  _Puttxt(px, pac);
  px->n0 = 0;
#if _DLIB_PRINTF_WIDTH_AND_PRECISION
  px->width = 0;
#endif
  if (pac != ac)
    free(pac);
  return (stat);
}
_STD_END

#endif /* _DLIB_PRINTF_MULTIBYTE */
/*
 * Copyright (c) 1992-2002 by P.J. Plauger.  ALL RIGHTS RESERVED.
 * Consult your license regarding permissions and restrictions.
V3.12:0576 */
