/* _Scanf function */
#include <ctype.h>
#include <stdlib.h>
#include <string.h>
#include "xstdio.h"
#include "xwchar.h"
#include "xwstdio.h"
_STD_BEGIN

int _Scanf(int (*pfn)(void *, int, int), 
           void *arg,
           const char *fmt,
           va_list *pap)
{       /* read formatted */
  int nconv = 0;
  _Sft x;
#if _DLIB_SCANF_MULTIBYTE
  _Mbstinit(mbst);
#endif /* _DLIB_SCANF_MULTIBYTE */

  x.pfn = pfn;
  x.arg = arg;
  x.ap = *pap;
  x.nchar = 0;
  for (x.s = fmt; ; ++x.s)
  {       /* parse format string */
    int ch;

    for (; ; )
    {       /* match any literal text or white-space */
#if _DLIB_SCANF_MULTIBYTE
      int n;
      wchar_t wc = L'\0';

      if ((n = _Mbtowc(&wc, x.s, INT_MAX, &mbst)) <= 0)
        n = *x.s == '\0' ? 0 : 1;       /* bad parse, eat one char */
      if (isspace(_Wctob(wc)))
      {       /* match any white-space */
        while (isspace(ch = GET(&x)))
          ;
        UNGETN(&x, ch);
      }
      else
      {       /* match any literal text */
        int m = wc == L'%' ? n - 1 : n;
        const char *s;

        for (s = x.s; 0 <= --m; ++s)
          if ((ch = GET(&x)) != *s)
          {       /* bad match */
            UNGETN(&x, ch);
            return (nconv);
          }
      }
      x.s += n;
      if (wc == L'%')
        break;
      else if (wc == L'\0')
        return (nconv);
#else
      if (isspace(*x.s))
      {
        while(isspace(ch = GET(&x)))
          ;
        UNGETN(&x, ch);
        x.s++;
      }
      else if (*x.s == '\0')
        return nconv;
      else if (*x.s == '%')
      {
        x.s++;
        break;
      }
      else
      {
        const char *s = x.s;
        if ((ch = GET(&x)) != *s)
        {       /* bad match */
          UNGETN(&x, ch);
          return (nconv);
        }
        x.s++;
      }
#endif /* _DLIB_SCANF_MULTIBYTE */
    }
    {      /* process a conversion specifier */
      int code;

#if _DLIB_SCANF_ASSIGNMENT_SUPPRESSING
      x.noconv = *x.s == '*' ? *x.s++ : '\0';
#endif
#if _DLIB_SCANF_WIDTH
      for (x.width = 0; isdigit(*x.s); ++x.s)
        if (x.width < _WMAX)
          x.width = x.width * 10 + *x.s - '0';
#endif /* _DLIB_SCANF_WIDTH */
#if _DLIB_SCANF_QUALIFIERS
#if _SCANF_INTERNAL_QUALIFIER_J
#define QUALIFIERS "hjltzL"
#else
#define QUALIFIERS "hltzL"
#endif

      x.qual = strchr(QUALIFIERS, *x.s) ? *x.s++ : '\0';        /* was hlL */
      if (x.qual == 'h' && *x.s == 'h')
        x.qual = 'b', ++x.s;
      else if (x.qual == 'l' && *x.s == 'l')
        x.qual = 'q', ++x.s;
#endif /* _DLIB_SCANF_QUALIFIERS */
      if (!strchr("cCn[", *x.s))
      {       /* match leading white-space */
        while (isspace(ch = GET(&x)))
          ;
        UNGETN(&x, ch);
      }
      if ((code = _Getfld(&x)) <= 0)
        return (nconv == 0 ? code : nconv);
      if (x.stored)
        ++nconv;
    }
  }
}
_STD_END

/*
 * Copyright (c) 1992-2002 by P.J. Plauger.  ALL RIGHTS RESERVED.
 * Consult your license regarding permissions and restrictions.
 V3.12:0576 */
