/* _Strerror function */
#include <errno.h>
#include <string.h>
#include "xtls.h"
_STD_BEGIN

#define INIT_STR	"error #xxx"
#define EBUF_SIZE	sizeof (INIT_STR)

_TLS_ARR_DEF(static, char, sbuf, EBUF_SIZE);

char *_Strerror(int errcode, char *buf)
	{	/* copy error message into buffer as needed */
	switch (errcode)
		{	/* switch on known error codes */
	case 0:
		return ("no error");
	case EDOM:
		return ("domain error");
	case ERANGE:
		return ("range error");
	case EFPOS:
		return ("file positioning error");
	case EILSEQ:
		return ("multibyte encoding error");
	default:
		if (errcode < 0 || _NERR <= errcode)
			return ("unknown error");
		else
			{	/* generate numeric error code */
			if (buf == 0)
				buf = _TLS_ARR(sbuf);
			strcpy(buf, INIT_STR);
			buf[9] = errcode % 10 + '0';
			buf[8] = (errcode /= 10) % 10 + '0';
			buf[7] = (errcode / 10) % 10 + '0';
			return (&buf[0]);
			}
		}
	}
_STD_END

/*
 * Copyright (c) 1992-2002 by P.J. Plauger.  ALL RIGHTS RESERVED.
 * Consult your license regarding permissions and restrictions.
V3.12:0576 */
