/* _WStopfx function */
#include <wctype.h>
#include <wchar.h>
#include "xmath.h"
_STD_BEGIN

int _WStopfx(const wchar_t **ps, wchar_t **endptr)
	{	/* parse prefix of floating-point field */
	const wchar_t *s = *ps;
	int code = 0;

	for (; iswspace(*s); ++s)
		;
	if (*s == L'-')
		code = FL_NEG, ++s;
	else if (*s == L'+')
		++s;
	if (_WLC(*s) == L'n')
		{	/* parse "nan" or fail */
		if ((_WLC(*++s) != L'a')
			|| (_WLC(*++s) != L'n'))
			code = FL_ERR;
		else if (*++s != L'(')
			code = FL_NAN;
		else
			{	/* parse (n-char-sequence) */
			for (; iswalnum(*++s) || *s == L'_'; )
				;
			if (*s != L')')
				code = FL_ERR;
			else
				code = FL_NAN, ++s;
			}
		if (endptr != 0)
			*endptr = (wchar_t *)s;
		}
	else if (_WLC(*s) == L'i')
		{	/* parse "inf" or fail */
		if ((_WLC(*++s) != L'n')
			|| (_WLC(*++s) != L'f'))
			code = FL_ERR;
		else if (_WLC(*++s) != L'i')
			code |= FL_INF;
		else
			{	/* parse rest of L"infinity" */
			if (   _WLC(*++s) != L'n'
                            || _WLC(*++s) != L'i'
                            || _WLC(*++s) != L't'
                            || _WLC(*++s) != L'y')
				code = FL_ERR;
			else
				code |= FL_INF, ++s;
			}
		if (endptr != 0)
			*endptr = (wchar_t *)s;
		}
#if _DLIB_STRTOD_HEX_FLOAT
	else if (   *s == L'0'
                 && (_WLC(*(s+1)) == L'x'))
                {
                        s += 2;
               		code |= FL_HEX;
                }
#endif
	else
                {
		        code |= FL_DEC;
                }
	*ps = s;
	return (code);
	}
_STD_END

/*
 * Copyright (c) 1992-2002 by P.J. Plauger.  ALL RIGHTS RESERVED.
 * Consult your license regarding permissions and restrictions.
V3.12:0576 */
