/* Taken from xdint.c, then exchanged F against T in all macros and
   further templified it. */

short FNAME(Dint)(FTYPE *px, short xexp)
{       /* test and drop (scaled) fraction bits */
  unsigned short *ps = (unsigned short *)px;
  unsigned short frac;
  short xchar = (ps[_X0] & _XMASK) >> _XOFF;

  if (xchar == _XMAX)
    return (   (ps[_X0] & _XFRAC) == 0
#if !__NAN_HAS_HIGH_MANTISSA_BIT_SET__
            && ps[_X1] == 0 && ps[_X2] == 0 && ps[_X3] == 0
#endif
            ? _INFCODE : _NANCODE);
  else if (   (ps[_X0] & ~_XSIGN) == 0
#if __SUBNORMAL_FLOATING_POINTS__
           && ps[_X1] == 0 && ps[_X2] == 0 && ps[_X3] == 0
#endif
          )
    return (0);
  xchar = (_XBIAS + 48 + _XOFF + 1) - xchar - xexp;
  if (xchar <= 0)
    return (0);     /* no frac bits to drop */
  else if ((48 + _XOFF + 1) <= xchar)
  {       /* all frac bits */
    ps[_X0] &= _XSIGN;
    ps[_X1] = 0;
    ps[_X2] = 0;
    ps[_X3] = 0;
    return (_FINITE);       /* report on frac, not result */
  }
  else
  {       /* strip out frac bits */
    static const unsigned short mask[] = {
      0x0000, 0x0001, 0x0003, 0x0007,
      0x000f, 0x001f, 0x003f, 0x007f,
      0x00ff, 0x01ff, 0x03ff, 0x07ff,
      0x0fff, 0x1fff, 0x3fff, 0x7fff};
    static const size_t sub[] = {_X3, _X2, _X1, _X0};

    frac = mask[xchar & 0xf];
    xchar >>= 4;
    frac &= ps[sub[xchar]];
    ps[sub[xchar]] ^= frac;
    switch (xchar)
    {       /* cascade through! */
    case 3:
      frac |= ps[_X1], ps[_X1] = 0;
    case 2:
      frac |= ps[_X2], ps[_X2] = 0;
    case 1:
      frac |= ps[_X3], ps[_X3] = 0;
    }
    return (frac != 0 ? _FINITE : 0);
  }
}
