/* xxstod.h -- _[W]Sto[d f ld] common functionality */

#define D16TO7	FLIT(268435456.0)	/* 16^7 */
#define D10TO9	FLIT(1e9)			/* 10^9 */
#define NLONG	((FBITS + 27) / 28)	/* 7 * NLONG == max hexadecimal digits */

/*
FTYPE _Stod(const CTYPE *s, CTYPE **endptr, long pten)
 */
	{	/* convert string to FTYPE, with checking */
	FTYPE x;
	long lo[NLONG + 1];
	const CTYPE *s0 = s;
	int code = CNAME(Stopfx)(&s, endptr);
	const int neg = code & FL_NEG;

	if ((code &= ~FL_NEG) == FL_DEC)
		{	/* parse decimal format */
		const int nlo = CNAME(Stoflt)(s0, s, endptr, lo, NLONG);

		if (nlo == 0)
			x = 0;
		else
 #if NLONG == 1
			x = lo[1];
 #else /* NLONG == 1 */
			{	/* combine longs, base 10^9 */
			int i;
			static const FTYPE fac[] =
				{	/* scale factors */
				D10TO9,
				D10TO9 * D10TO9,
  #if 2 < NLONG
				D10TO9 * D10TO9 * D10TO9,
   #if 3 < NLONG
				D10TO9 * D10TO9 * D10TO9 * D10TO9,
    #if 4 < NLONG
				D10TO9 * D10TO9 * D10TO9 * D10TO9 * D10TO9,
     #if 5 < NLONG
      #error NLONG TOO BIG
     #endif /* 5 < NLONG */
    #endif /* 4 < NLONG */
   #endif /* 3 < NLONG */
  #endif /* 2 < NLONG */
				};

			for (i = nlo, x = lo[nlo]; 0 < --i; )
				if (lo[i] != 0)
					x += fac[nlo - i - 1] * lo[i];
			 }
 #endif /* NLONG == 1 */
		x = FNAME(Dtento)(x, pten + lo[0]);
		}
#if _DLIB_STRTOD_HEX_FLOAT
	else if (code == FL_HEX)
		{	/* parse hexadecimal format */
		const int nlo = CNAME(Stoxflt)(s0, s, endptr, lo, NLONG);

		if (nlo == 0)
			x = 0;
		else
 #if NLONG == 1
			x = lo[1];
 #else /* NLONG == 1 */
			{	/* combine longs, base 16^7 */
			int i;
			static const FTYPE fac[] =
				{	/* scale factors */
				D16TO7,
				D16TO7 * D16TO7,
  #if 2 < NLONG
				D16TO7 * D16TO7 * D16TO7,
   #if 3 < NLONG
				D16TO7 * D16TO7 * D16TO7 * D16TO7,
    #if 4 < NLONG
				D16TO7 * D16TO7 * D16TO7 * D16TO7 * D16TO7,
     #if 5 < NLONG
      #error NLONG TOO BIG
     #endif /* 5 < NLONG */
    #endif /* 4 < NLONG */
   #endif /* 3 < NLONG */
  #endif /* 2 < NLONG */
				};

			for (i = nlo, x = lo[nlo]; 0 < --i; )
				if (lo[i] != 0)
					x += fac[nlo - i - 1] * lo[i];
			 }
 #endif /* NLONG == 1 */
		FNAME(Dscale)(_D_PTRCAST &x, lo[0]);
		x = FNAME(Dtento)(x, pten);
		}
#endif /* _DLIB_STRTOD_HEX_FLOAT */
	else if (code == FL_INF)
		x = FCONST(Inf);
	else if (code == FL_NAN)
		x = FCONST(Nan);
	else
		x = 0;	/* code == FL_ERR */
	return (neg != 0 ? -x : x);
	}

/*
* Copyright (c) 1992-2002 by P.J. Plauger.  ALL RIGHTS RESERVED.
 * Consult your license regarding permissions and restrictions.
V3.12:0576 */
